#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "../include/ephi.h"

struct eh ephihdr;
struct ei ephi;

int debug= 0; /* for ephinterp.c */

main ()
{
  double jdint, seci;
  double outvec[6], backvec[6], aberout[3], aberback[3];
  double relcorrout, relcorrback;
  int fvel= 1;	/* gimme velocities - make 'em up if necessary */
  int i;
  int ircode;	/* Failure? */
  char str[256] = "tabl_y2015d038t2222_9117.0259.COD";


  printf ("Non-leap second interpolation test\n\n");
  if (cephinit (str) != 0)
    {
      printf("File %s does not exist.\n",str);
      exit;
    }


  jdint= 2400000.5e0+ 57060.0e0;
  seci= 86384.000000;
  for (i=0;i<=180;i++)
    {
      cinterp_pvac (jdint, seci, outvec, backvec, aberout, aberback, 
          &relcorrout, &relcorrback, fvel, &ircode);
      printf ("%9.1f %8.2f%20.3f%20.3f%20.3f\n", 
          jdint-2400000.5e0, seci, outvec[0],outvec[1],outvec[2]);
      printf ("                  %20.6f%20.6f%20.6f\n", 
          outvec[3],outvec[4],outvec[5]);

      seci+= 5;
      if (seci >= 86400.e0)
        {
          jdint= jdint+ 1;
          seci= seci- 86400.e0;
        }
    }
  exit (0);
}
