	SUBROUTINE DATE_TIME(MODJDAY, YEAR, MONTH, DAY ,HOUR ,MIN ,RSEC,
     $				IDOY)
C***********************************************************************
C
C
C	THIS CONVERTS FROM MODIFIED JULIAN DAY TO STANDARD
C	YEAR,MONTH,DAY FORMAT
C
C		CALLS
C			SECS_TIME
C
C		CALLED BY
C
C***********************************************************************
CC	EXTERNAL YMDTODOY,SECS_TIME
	INTEGER*4 YEAR,MONTH,DAY,HOUR,MIN,IDOY
	INTEGER JD,I,J,L,N
	REAL*8 MODJDAY,FP,TSEC,RYEAR,RMONTH,RDAY,RSEC

	YEAR = 0
	MONTH = 0
	DAY = 0
	HOUR = 0
	MIN = 0
	IDOY = 0
	JD = INT (MODJDAY)
	FP = MODJDAY - JD + 0.5D0
	IF ( FP .LT. 0.5D0 ) GO TO 20
	FP = FP - 0.5D0
	JD = JD + 1
	GO TO 30
  20    FP = FP + 0.5D0
  30    CONTINUE
	TSEC = FP * 0.86400D5
	CALL SECS_TIME(DAY, HOUR, MIN, RSEC, TSEC)
	L = JD + 68569 + 2400000
	L = L + DAY
	N = 4 * L/146097
	L = L - (146097 * N + 3) / 4
	I = 4000 * ( L+1) / 1461001
	L = L - 1461 * I/4 + 31
	J = 80 * L/2447
CC	RDAY = DFLOTJ(L - 2447 * J/80)
	RDAY = DBLE(L - 2447 * J/80)
	L = J/11
CC	RMONTH = DFLOTJ(J + 2 - 12*L)
CC	RYEAR  = DFLOTJ(100 * ( N - 49) + I + L - 1900)
	RMONTH = DBLE(J + 2 - 12*L)
	RYEAR  = DBLE(100 * ( N - 49) + I + L - 1900)
	YEAR = RYEAR
	MONTH = RMONTH
	DAY = RDAY
	CALL YMDTODOY(YEAR,MONTH,DAY,IDOY)
	RETURN
	END


**********************************************************************
*	SUBROUTINE SECS_TIME
*
      SUBROUTINE SECS_TIME(DAY, HR, MN, SEC, SECS)
*
*PURPOSE
*	CONVERTS SECONDS OF DAY INTO DAY, HOUR , MINUTE AND SECOND
*
*DESCRIPTION OF PARAMETERS
*	VARIABLES:
*			SECS  = SECONDS OF DAY
*			DAY   = DAY
*			HR    = HOUR OF DAY
*			MN    = MINUTES OF HOUR
*
*SUBROUTINE AND FUNCTIONS USED
*	NONE
*
*COMMENTS
*	REJ/ /84
**********************************************************************

      IMPLICIT NONE

      REAL*8 SECS, SEC, TSECS
      INTEGER*4 HR, MN ,DAY

CTURN SECONDS OF DAY INTO HOURS, MINUTES, AND SECONDS
      DAY = DAY + SECS/86400
      TSECS = DMOD(SECS,86400.D0)
      HR = SECS/3600
      MN = (SECS - HR*3600)/60
      SEC = SECS - HR*3600 - MN*60

CTURN THESE VALUES REAL SO AS TO FIT THE DATA STRUCTURE

      RETURN
	END

	SUBROUTINE YMDTODOY(YEAR,MONTH,DAY,IDOY)
	INTEGER*4 MONTH,YEAR,DAY,IDOY

	REAL TEST

	IF(MONTH .EQ. 1) THEN
		IDOY =  0
	ELSE IF (MONTH .EQ. 2) THEN
		IDOY = 31
	ELSE IF (MONTH .EQ. 3) THEN
		IDOY = 59
	ELSE IF (MONTH .EQ. 4) THEN
		IDOY = 90
	ELSE IF (MONTH .EQ. 5) THEN
		IDOY = 120
	ELSE IF (MONTH .EQ. 6) THEN
		IDOY = 151
	ELSE IF (MONTH .EQ. 7) THEN
		IDOY = 181
	ELSE IF (MONTH .EQ. 8) THEN
		IDOY = 212
	ELSE IF (MONTH .EQ. 9) THEN
		IDOY = 243
	ELSE IF (MONTH .EQ. 10) THEN
		IDOY = 273
	ELSE IF (MONTH .EQ. 11) THEN
		IDOY = 304
	ELSE IF (MONTH .EQ. 12) THEN
		IDOY = 334
	END IF
C TEST FOR LEAP YEAR
	TEST = (YEAR / 4.0)
	TEST = TEST - FLOAT(INT(TEST))
	IF ((TEST .EQ. 0.0).AND.(MONTH .GT.2)) IDOY = IDOY + 1
	IDOY = IDOY + DAY
	RETURN
	END
