/* This routine reads a file containing filenames of schedule files (.sch).
(This file was created by the xgpca script when generating IRVs.)  Each file is
opened and the contents are read into an array containing all pertenent info
needed to sort and generate a chronological schedule file of passes which can be used by the crew.

	030193	-	changed IYEAR to YEAR in gettime.f (Was always leap 
			year) - kse
	04xx95 	-	Added MLRS schedule format. To produce MLRS schedule,
			the first argument should be something other than '0'
			or blank. Otherwise the ATSC format is produced. - rlr

   Compile with
    cc schedule.c -o schedule

*/
static char schedule[] = "%W%\t%G%";
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAXSAT 2000
main(argc,argv)
int argc;
char *argv[];
{
FILE *sched_fil, *file_in;
char chr[4], fquit, ans,header1[256], header2[256], tar[25][2],  tarin[2]; 
char *gets(), ans2[20];
char header3[256], string[256], curfile[256], filename[256];
/*char sched_filename[256] = "/data/slr/irv/schedule.fil";*/
char sched_filename[256] = "../data/schedule.fil";
int ii, itar, toupper(), fchanged=0, fslot=0, fexists=0;
int satid,  epm, year, month, day, hour, min,  num=0, dum;
int dhour,dmin, ryear,rmonth,rday,rhour,rmin,rdoy,phour,pmin,shour,smin;
int sihour,simin,sohour,somin,ilhour,ilmin,uilhour,uilmin;
int headcnt;
register a, b;
double ttime[MAXSAT],taz[MAXSAT], tel[MAXSAT], trng[MAXSAT];
double ptime[MAXSAT],paz[MAXSAT], pel[MAXSAT], prng[MAXSAT];
double stime[MAXSAT],saz[MAXSAT], sel[MAXSAT], srng[MAXSAT];
double sitime[MAXSAT],sotime[MAXSAT],iltime[MAXSAT],uiltime[MAXSAT];
int psatid[MAXSAT], pepm[MAXSAT], temp13, temp14, idoy;
int format;		/* 0=> ATSC 3-line schedule format. 1=> MLRS a line format */
short int validfg[MAXSAT], temp15;
double fdum1, fdum2, fdum3, fdum4, fdum5, fdum6, fdum7, fdum8, temp;
double temp2, temp3, temp4, temp5, temp6, temp7, temp8;
double temp9, temp10, temp11, temp12, rsec, daz1, daz2, daz3;
double temp16, temp17, temp18, temp19;
double duration,rngtoms=149.896229;

	strcpy(chr," CW");
	if (argc > 1) format= atoi(argv[1]);
	else format= 0;
	if (argc > 2) strcpy(sched_filename,argv[2]);
	sched_fil = fopen(sched_filename,"r");
/*printf("sched file [%s]\n",sched_filename);*/
	if( sched_fil == NULL) {
		perror ("Could not open schedule file.\n");
		exit(1);
	} /* end if */
	while ( !feof(sched_fil))  {   /* do for each file in schedule.fil */
		fscanf( sched_fil,"%s\n",curfile); /* read a file name */
		strcpy(filename,curfile);
		strcat(filename,".schtmp");
/*printf("fn [%s]\n",filename);*/
		file_in = fopen(filename,"r");
		if( file_in == NULL) {
			sprintf (string, "Could not open %s\n",curfile);
			perror (string);
			continue; /*exit(1);*/
		} /* end if */
		if(fscanf(file_in,"%d%d%d%d",&satid,&epm,&temp13,&temp14) == EOF) { 
			printf("Not a schedule file\n");
			continue; /*exit(1);*/
		} /* end if */
/*printf("%d %d %d %d\n",satid,epm,temp13,temp14);*/
/*		while ( !feof(file_in)) { */
		while (	fscanf(file_in,"%lf%lf%lf",&ttime[num],&taz[num],&tel[num]) != EOF) {;
			fscanf(file_in,"%lf%lf%lf",&trng[num],&stime[num],&saz[num]);
			fscanf(file_in,"%lf%lf%lf",&sel[num],&srng[num],&ptime[num]);
			fscanf(file_in,"%lf%lf%lf%lf",&paz[num],&pel[num],&prng[num],&fdum1);
			fscanf(file_in,"%lf%lf%lf",&fdum1,&fdum2,&fdum3);
			fscanf(file_in,"%lf%lf%lf%lf%lf%lf%lf%lf%lf",&fdum1,&fdum2,
				/**&fdum3,&fdum4,&fdum5,&fdum6,&fdum7,&fdum8);**/
				&fdum3,&fdum4,&fdum5,&iltime[num],&uiltime[num],
				&sitime[num],&sotime[num]);
			validfg[num] = fdum5; /* save valid pca indicator */
			psatid[num] = satid;
			pepm[num] = epm;
/*printf("%d %f %f %f\n",num,ttime[num],taz[num],tel[num]);*/
				num++;
			if(num > MAXSAT){
				printf("Too many IRVs - aborting schedule\n");
				return;
			}
		} /* end while ! feof(file_in) */
	} /* end while !feof */
	/* now sort them */
		for(a=1; a<num; ++a) {
			temp = ttime[a]; /* the actual sort is done on this key */
			temp2 = taz[a];
			temp3 = tel[a];
			temp4 = trng[a];
			temp5 = ptime[a];
			temp6 = paz[a];
			temp7 = pel[a];
			temp8 = prng[a];
			temp9 = stime[a];
			temp10 = saz[a];
			temp11 = sel[a];
			temp12 = srng[a];
			temp13 = psatid[a];
			temp14 = pepm[a];
			temp15 = validfg[a];
			temp16 = sitime[a];
			temp17 = sotime[a];
			temp18 = iltime[a];
			temp19 = uiltime[a];

			for(b=a-1;b >= 0 && temp < ttime[b]; b--) {
				ttime[b+1] = ttime[b];
				taz[b+1] = taz[b];
				tel[b+1] = tel[b];
				trng[b+1] = trng[b];
				ptime[b+1] = ptime[b];
				paz[b+1] = paz[b];
				pel[b+1] = pel[b];
				prng[b+1] = prng[b];
				stime[b+1] = stime[b];
				saz[b+1] = saz[b];
				sel[b+1] = sel[b];
				srng[b+1] = srng[b];
				psatid[b+1] = psatid[b];
				pepm[b+1] = pepm[b];
				validfg[b+1] = validfg[b];
				sitime[b+1] = sitime[b];
				sotime[b+1] = sotime[b];
				iltime[b+1] = iltime[b];
				uiltime[b+1] = uiltime[b];
			}
			ttime[b+1] = temp;
			taz[b+1] = temp2;
			tel[b+1] = temp3;
			trng[b+1] = temp4;
			ptime[b+1] = temp5;
			paz[b+1] = temp6; 
			pel[b+1] = temp7;
			prng[b+1] = temp8;
			stime[b+1] = temp9;
			saz[b+1] = temp10;
			sel[b+1] = temp11;
			srng[b+1] = temp12;
			psatid[b+1] = temp13;
			pepm[b+1] = temp14;
			validfg[b+1] = temp15;
			sitime[b+1] = temp16;
			sotime[b+1] = temp17;
			iltime[b+1] = temp18;
			uiltime[b+1] = temp19;
		}

		headcnt = 0;
		for(ii =0; ii < num; ii++) {
		   if(validfg[ii] == 2) { /* only do if valid pca */
			/* 1st decide whether clockwise or counter-clockwise */
			daz1 = paz[ii] - taz[ii];
			daz2 = saz[ii] - paz[ii];
			daz3 = saz[ii] - taz[ii];

			if (daz1 > 0. && daz2 > 0. && daz3 > 0.)
				strcpy(chr," CW");
			if (daz1 > 0. && daz2 < 0. && daz3 < 0.)
				strcpy(chr," CW");
			if (daz1 < 0. && daz2 > 0. && daz3 < 0.)
				strcpy(chr," CW");
			if (daz1 < 0. && daz2 < 0. && daz3 < 0.)
				strcpy(chr,"CCW");
			if (daz1 > 0. && daz2 < 0. && daz3 > 0.)
				strcpy(chr,"CCW");
			if (daz1 < 0. && daz2 > 0. && daz3 > 0.)
				strcpy(chr,"CCW");

		/* duration of pass */
			duration = stime[ii] - ttime[ii];
			date_time__(&duration,&year, &month, &day, &dhour, &dmin, &rsec, &idoy);
/**
printf("start %f stop %f duration %f  %d:%d\n",ttime[ii],stime[ii],duration,dhour,dmin);
**/
			/**if(headcnt % 13 == 0)**/
			if(headcnt == 0)
			   if (format == 0) {
					printf("\f Doy (MM/DD/YY)   Sic  Epm  Dir Dur(HHMM) HHMM     Azm    Elv      Range\n\n");
				} else {
					printf("\n\n");
					printf("                                             Laser Ranging Target Predictions\n");
					printf("                                             **********************************\n\n");
					printf("                         RISE                    TCA                      SET\n");
					printf("                         ****                    ***                      ***\n");
					printf(" SIC YEAR/MN/DY  H:M    AZ  EL       AZ   EL     RANGE          H:M     AZ   EL       FILENAME         DOY SUN-IN SUN-OUT  ILLUM UNILLUM\n");
				}
			date_time__(&ttime[ii],&ryear,&rmonth,&rday, &rhour,&rmin,&rsec, &rdoy);
			date_time__(&ptime[ii],&year,&month,&day, &phour,&pmin,&rsec, &idoy);
			date_time__(&stime[ii],&year,&month,&day, &shour,&smin,&rsec, &idoy);
			if (format == 0) {
				printf(" %03d  %02d/%02d/%02d   %4d  %3d  %3s     %02d%02d  %02d%02d   %5.1f  %5.1f  %9.1f\n",
					idoy,month,day,year,psatid[ii],pepm[ii],chr,dhour,dmin,
					rhour,rmin, taz[ii],tel[ii],trng[ii]/rngtoms);
				printf("                                          %02d%02d   %5.1f  %5.1f  %9.1f\n",
					phour,pmin, paz[ii],pel[ii],prng[ii]/rngtoms);
				printf("                                          %02d%02d   %5.1f  %5.1f  %9.1f\n\n",
					shour,smin, saz[ii],sel[ii],srng[ii]/rngtoms);
			} else {
				date_time__(&sitime[ii],&year,&month,&day, 
					&sihour,&simin,&rsec, &idoy);
				date_time__(&sotime[ii],&year,&month,&day, 
					&sohour,&somin,&rsec, &idoy);
				date_time__(&iltime[ii],&year,&month,&day, 
					&ilhour,&ilmin,&rsec, &idoy);
				date_time__(&uiltime[ii],&year,&month,&day, 
					&uilhour,&uilmin,&rsec, &idoy);
				printf("%04d %4d/%02d/%02d %02d:%02d %4d %3d     %4d  %3d%11.0f.ns     %02d:%02d  %4d  %3d                        %03d  %02d:%02d  %2d:%02d  %2d:%02d  %2d:%02d\n",
					psatid[ii],ryear+1900,rmonth,rday,
					rhour,rmin, (int)taz[ii],(int)tel[ii],
								(int)paz[ii],(int)pel[ii],prng[ii]/rngtoms*1000.,
					shour,smin, (int)saz[ii],(int)sel[ii],
					rdoy,sihour,simin, sohour,somin,
					ilhour,ilmin, uilhour,uilmin);
			}
			headcnt++;
		   } /* end if validfg == 2 */
		} /* end for */
}				
/* Can't get ot htis in fortran library ??? */
#include <math.h>
double d_mod(double *a, double *b)
{
   return(fmod(*a,*b));
}
